<?php

/**
 * inf_exogena_dian actions.
 * 1.  Corregir la generación del archivo de INFORMACION EXOGENA DIAN DE nómina,  
 * para que al sumar el resultado de la AGRUPACION seleccioanda tenga en cuenta realizar 
 * la sumatoria de acuerdo con el operador de cada concepto especificado en la agrupación.--20140929
 *
 * @package    nomina
 * @subpackage inf_exogena_dian
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_exogena_dianActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $vigencia = $request['id_anhos'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

tab.id_tipo_doc,
tab.num_doc,
dat.nombre_apellido,
dat.nombre_completo,
dat.direccion,
tab.id_anhos,
sum( case when tab.agrupacion_orden = 1 then tab.valor_total else 0 end ) as deven,
sum( case when tab.agrupacion_orden = 5 then tab.valor_total else 0 end ) as reten

from(

select 
tab0.id_certif_ingre_reten_dian,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_anhos,
tab0.id_concep_nomina,

tab0.valor_total as valor_total,
--case when tab2.operador = 1 then tab0.valor_total else tab0.valor_total * (-1) end as valor_total,                    
                    
tab0.agrupacion_orden
from no_certif_ingre_reten_dian tab0

JOIN NO_CONCEPTOS_V tab2 ON tab0.id_concep_nomina = tab2.id_concep_nomina
                    
where tab0.id_anhos = $vigencia                    
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
and ( tab0.agrupacion_orden = 1 or tab0.agrupacion_orden = 5 )

)tab

join no_datos_funcionario_v dat
on tab.id_tipo_doc = dat.id_tipo_doc
and tab.num_doc = dat.num_doc

group by
tab.id_tipo_doc,
tab.num_doc,
tab.id_anhos,
dat.nombre_apellido,
dat.nombre_completo,
dat.direccion
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

tab.id_tipo_doc,
tab.num_doc,
dat.nombre_apellido,
dat.nombre_completo,
dat.direccion,
tab.id_anhos,
sum( case when tab.agrupacion_orden = 1 then tab.valor_total else 0 end ) as deven,
sum( case when tab.agrupacion_orden = 5 then tab.valor_total else 0 end ) as reten

from(

select 
tab0.id_certif_ingre_reten_dian,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.id_anhos,
tab0.id_concep_nomina,

tab0.valor_total as valor_total,
--case when tab2.operador = 1 then tab0.valor_total else tab0.valor_total * (-1) end as valor_total,                    
                    
tab0.agrupacion_orden
from no_certif_ingre_reten_dian tab0

JOIN NO_CONCEPTOS_V tab2 ON tab0.id_concep_nomina = tab2.id_concep_nomina
                    
where tab0.id_anhos = $vigencia                    
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
and ( tab0.agrupacion_orden = 1 or tab0.agrupacion_orden = 5 )

)tab

join no_datos_funcionario_v dat
on tab.id_tipo_doc = dat.id_tipo_doc
and tab.num_doc = dat.num_doc

group by
tab.id_tipo_doc,
tab.num_doc,
tab.id_anhos,
dat.nombre_apellido,
dat.nombre_completo,
dat.direccion
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_exogena_dian] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
